use std::collections::HashMap;
use anyhow::{bail, Result};
use tracing::{info, error, instrument};
use std::sync::mpsc::{Sender, Receiver};
use std::sync::mpsc;
use std::thread;
use std::thread::Thread;

pub struct Context {
    pub urls: HashMap<String, String>,
    pub threads: Vec<std::thread::JoinHandle<Result<String, anyhow::Error>>>
}

impl Default for Context {
    fn default() -> Self {
        Self {
            urls: HashMap::from([
                (
                    "n100".to_string(),
                    "https://www.ebay.com/sch/i.html?_from=R40&_nkw=n100&_sacat=171957&_sop=15&_blrs=recall_filtering&_ipg=240".to_string()
                ),
                (
                    "n305".to_string(),
                    "https://www.ebay.com/sch/i.html?_from=R40&_nkw=n305&_sacat=171957&_sop=15&_blrs=recall_filtering&_ipg=240".to_string()
                )
            ]),
            threads: Vec::new()
        }
    }
}

impl Context {
    pub fn ebay_fetch_html(&mut self, filename: String, url: String, outdir_dir: String) -> Result<()> {
        let thr = thread::spawn(move || {
            // let body = reqwest::blocking::get(url)?.text()?;

            if url.is_empty() {
                Ok("hello".to_string())
            } else {
                bail!("hmmm")
            }
        });
        self.threads.push(thr);

        Ok(())
    }
}

